#
# Eggdrop Background Command Execution Version 1.0
# By Fosters@G0
#
# (c) Copyright 1998 Eden Developments
#     All Rights Reserved.
#

# Path to bgexec executable
set bgexec_path "/home/fosters/bin/bgexec"

# Interval in seconds for checking for completion
set bgcheck 3

# Dont touch these unless you want everything to die :)
set bgexecver 1
set bgexecrev 2
set watchthese ""


# Execute in background: command = command and args,
#                        proctocall = proc to call when finished,
#						 prinfo = arg to proc
#
# proc wil be called with the tmpfile and prinfo as arguments
proc execbg { command proctocall prinfo } {
	global bgexecpath bgcheck watchthese
	
	set tmpfile "/tmp/bgexec.[clock seconds]"
	
	lappend watcher $tmpfile
	lappend watcher $proctocall
	lappend watcher $prinfo
	lappend watchthese $watcher
	
	utimer $bgcheck bg_checkfiles
	
	# This is in the bgexec module
	bgexec $tmpfile $command
}

proc bg_checkfiles { } {
	global bgcheck watchthese
	
	set newwatch ""
	foreach watch $watchthese {
		if { [file exists [lindex $watch 0]] == 1 } {
			set tmpfile [lindex $watch 0]
			set proctocall [lindex $watch 1]
			set prinfo [lindex $watch 2]
			
			$proctocall $tmpfile $prinfo
			
			file delete $tmpfile
		} else {
			lappend newwatch $watch
		}
	}
	
	if { $newwatch != "" } {
		set watchthese $newwatch
		utimer $bgcheck bg_checkfiles
	}
}

putlog "BGExec Version $bgexecver.$bgexecrev loaded..."
